BEGIN {
  nsig = 0;
  last_sig = 0;
}

/^#define/ {
  sig = $3 + 0;
  if (sig != 0) {
    if ($2 == "NSIG") {
      nsig = sig;
    } else if ( (substr($2,1,3) == "SIG") && (substr($2,4,1) != "_") ) {
      if ((sig <= nsig) && (sig != last_sig)) {
        last_sig = sig;
        signals[sig] = $2;
      }
    }
  }
}

END {
  print "/* This file was automatically generated by the awk script \"sigconv.awk\".*/\n"
  printf "static bits signal_names[NSIG+1] = {\t/* %s */\n", nsig
  for (sig = 1; sig <= nsig; sig++) {
    if (strlen(signals[sig])) {
      printf "#ifdef\t%s\n", signals[sig]
      printf "\t{ %s,\t\"%s\" },\t/* %s */\n", \
       signals[sig], substr(signals[sig], 4), sig
      printf "#else\t%s\n", signals[sig]
    }
    printf "\t{ 0,\t\tNULL },\t\t/* %s */\n", sig
    if (strlen(signals[sig])) {
      printf "#endif\t%s\n", signals[sig]
    }
  }
  print "\t{ 0, \t\tNULL }\t\t/* EOL */\n};"
}
